/* ClipboardStore.c generated by valac 0.56.16, the Vala compiler
 * generated from ClipboardStore.vala, do not modify */

/*
* Copyright (c) 2017 David Hewitt (https://github.com/davidmhewitt)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: David Hewitt <davidmhewitt@gmail.com>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <sqlite3.h>
#include <gio/gio.h>
#include <gee.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CLIPPED_TYPE_CLIPBOARD_STORE (clipped_clipboard_store_get_type ())
#define CLIPPED_CLIPBOARD_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLIPPED_TYPE_CLIPBOARD_STORE, ClippedClipboardStore))
#define CLIPPED_CLIPBOARD_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CLIPPED_TYPE_CLIPBOARD_STORE, ClippedClipboardStoreClass))
#define CLIPPED_IS_CLIPBOARD_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLIPPED_TYPE_CLIPBOARD_STORE))
#define CLIPPED_IS_CLIPBOARD_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CLIPPED_TYPE_CLIPBOARD_STORE))
#define CLIPPED_CLIPBOARD_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CLIPPED_TYPE_CLIPBOARD_STORE, ClippedClipboardStoreClass))

typedef struct _ClippedClipboardStore ClippedClipboardStore;
typedef struct _ClippedClipboardStoreClass ClippedClipboardStoreClass;
typedef struct _ClippedClipboardStorePrivate ClippedClipboardStorePrivate;
enum  {
	CLIPPED_CLIPBOARD_STORE_0_PROPERTY,
	CLIPPED_CLIPBOARD_STORE_NUM_PROPERTIES
};
static GParamSpec* clipped_clipboard_store_properties[CLIPPED_CLIPBOARD_STORE_NUM_PROPERTIES];
typedef enum  {
	CLIPPED_CLIPBOARD_STORE_CLIPBOARD_ENTRY_TYPE_TEXT
} ClippedClipboardStoreClipboardEntryType;

#define CLIPPED_CLIPBOARD_STORE_TYPE_CLIPBOARD_ENTRY_TYPE (clipped_clipboard_store_clipboard_entry_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))

#define CLIPPED_CLIPBOARD_STORE_TYPE_CLIPBOARD_ENTRY (clipped_clipboard_store_clipboard_entry_get_type ())
typedef struct _ClippedClipboardStoreClipboardEntry ClippedClipboardStoreClipboardEntry;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ClippedClipboardStore {
	GObject parent_instance;
	ClippedClipboardStorePrivate * priv;
};

struct _ClippedClipboardStoreClass {
	GObjectClass parent_class;
};

struct _ClippedClipboardStorePrivate {
	gchar* db_location;
	sqlite3* db;
	guint retention_period_days;
};

struct _ClippedClipboardStoreClipboardEntry {
	gint id;
	ClippedClipboardStoreClipboardEntryType type;
	GDateTime* date_copied;
	gchar* text;
	gchar* application_id;
	gchar* application_name;
	gchar* optional_uri;
	gint optional_int;
};

static gint ClippedClipboardStore_private_offset;
static gpointer clipped_clipboard_store_parent_class = NULL;

VALA_EXTERN GType clipped_clipboard_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ClippedClipboardStore, g_object_unref)
VALA_EXTERN GType clipped_clipboard_store_clipboard_entry_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ClippedClipboardStore* clipped_clipboard_store_new (guint retention_period);
VALA_EXTERN ClippedClipboardStore* clipped_clipboard_store_construct (GType object_type,
                                                          guint retention_period);
static gboolean clipped_clipboard_store_open_database (ClippedClipboardStore* self);
static void clipped_clipboard_store_prepare_database (ClippedClipboardStore* self);
VALA_EXTERN void clipped_clipboard_store_set_retention_days (ClippedClipboardStore* self,
                                                 guint days);
VALA_EXTERN void clipped_clipboard_store_insert_text_item (ClippedClipboardStore* self,
                                               const gchar* text);
static void clipped_clipboard_store_purge_older_entries (ClippedClipboardStore* self);
VALA_EXTERN GType clipped_clipboard_store_clipboard_entry_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ClippedClipboardStoreClipboardEntry* clipped_clipboard_store_clipboard_entry_dup (const ClippedClipboardStoreClipboardEntry* self);
VALA_EXTERN void clipped_clipboard_store_clipboard_entry_free (ClippedClipboardStoreClipboardEntry* self);
VALA_EXTERN void clipped_clipboard_store_clipboard_entry_copy (const ClippedClipboardStoreClipboardEntry* self,
                                                   ClippedClipboardStoreClipboardEntry* dest);
VALA_EXTERN void clipped_clipboard_store_clipboard_entry_destroy (ClippedClipboardStoreClipboardEntry* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (ClippedClipboardStoreClipboardEntry, clipped_clipboard_store_clipboard_entry_destroy)
VALA_EXTERN GeeArrayList* clipped_clipboard_store_get_most_recent_items (ClippedClipboardStore* self,
                                                             gint limit);
VALA_EXTERN GeeArrayList* clipped_clipboard_store_search (ClippedClipboardStore* self,
                                              const gchar* search_term,
                                              const gchar* app_search_term,
                                              gint limit);
VALA_EXTERN void clipped_clipboard_store_select_item (ClippedClipboardStore* self,
                                          gint id);
static void clipped_clipboard_store_touch_access_date (ClippedClipboardStore* self,
                                                gint id);
VALA_EXTERN void clipped_clipboard_store_delete_item (ClippedClipboardStore* self,
                                          gint id);
static void clipped_clipboard_store_finalize (GObject * obj);
static GType clipped_clipboard_store_get_type_once (void);

static inline gpointer
clipped_clipboard_store_get_instance_private (ClippedClipboardStore* self)
{
	return G_STRUCT_MEMBER_P (self, ClippedClipboardStore_private_offset);
}

static GType
clipped_clipboard_store_clipboard_entry_type_get_type_once (void)
{
	static const GEnumValue values[] = {{CLIPPED_CLIPBOARD_STORE_CLIPBOARD_ENTRY_TYPE_TEXT, "CLIPPED_CLIPBOARD_STORE_CLIPBOARD_ENTRY_TYPE_TEXT", "text"}, {0, NULL, NULL}};
	GType clipped_clipboard_store_clipboard_entry_type_type_id;
	clipped_clipboard_store_clipboard_entry_type_type_id = g_enum_register_static ("ClippedClipboardStoreClipboardEntryType", values);
	return clipped_clipboard_store_clipboard_entry_type_type_id;
}

GType
clipped_clipboard_store_clipboard_entry_type_get_type (void)
{
	static volatile gsize clipped_clipboard_store_clipboard_entry_type_type_id__once = 0;
	if (g_once_init_enter (&clipped_clipboard_store_clipboard_entry_type_type_id__once)) {
		GType clipped_clipboard_store_clipboard_entry_type_type_id;
		clipped_clipboard_store_clipboard_entry_type_type_id = clipped_clipboard_store_clipboard_entry_type_get_type_once ();
		g_once_init_leave (&clipped_clipboard_store_clipboard_entry_type_type_id__once, clipped_clipboard_store_clipboard_entry_type_type_id);
	}
	return clipped_clipboard_store_clipboard_entry_type_type_id__once;
}

ClippedClipboardStore*
clipped_clipboard_store_construct (GType object_type,
                                   guint retention_period)
{
	ClippedClipboardStore * self = NULL;
	gchar* config_dir_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* config_dir = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	gboolean _tmp13_;
	GError* _inner_error0_ = NULL;
	self = (ClippedClipboardStore*) g_object_new (object_type, NULL);
	self->priv->retention_period_days = retention_period;
	_tmp0_ = g_get_user_config_dir ();
	_tmp1_ = g_build_path (G_DIR_SEPARATOR_S, _tmp0_, "clipped", NULL);
	config_dir_path = _tmp1_;
	_tmp2_ = config_dir_path;
	_tmp3_ = g_file_new_for_path (_tmp2_);
	config_dir = _tmp3_;
	_tmp4_ = config_dir;
	if (!g_file_query_exists (_tmp4_, NULL)) {
		{
			GFile* _tmp5_;
			_tmp5_ = config_dir;
			g_file_make_directory_with_parents (_tmp5_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp6_;
			const gchar* _tmp7_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp6_ = e;
			_tmp7_ = _tmp6_->message;
			g_warning ("ClipboardStore.vala:52: Failed to create directory to store clipboard " \
"data: %s", _tmp7_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (config_dir);
			_g_free0 (config_dir_path);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp8_ = config_dir_path;
	_tmp9_ = g_build_path (G_DIR_SEPARATOR_S, _tmp8_, "ClipboardStore.sqlite", NULL);
	_g_free0 (self->priv->db_location);
	self->priv->db_location = _tmp9_;
	_tmp10_ = self->priv->db_location;
	_tmp11_ = g_file_new_for_path (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_file_query_exists (_tmp12_, NULL);
	_g_object_unref0 (_tmp12_);
	if (_tmp13_) {
		clipped_clipboard_store_open_database (self);
	} else {
		clipped_clipboard_store_open_database (self);
		clipped_clipboard_store_prepare_database (self);
	}
	_g_object_unref0 (config_dir);
	_g_free0 (config_dir_path);
	return self;
}

ClippedClipboardStore*
clipped_clipboard_store_new (guint retention_period)
{
	return clipped_clipboard_store_construct (CLIPPED_TYPE_CLIPBOARD_STORE, retention_period);
}

void
clipped_clipboard_store_set_retention_days (ClippedClipboardStore* self,
                                            guint days)
{
	g_return_if_fail (self != NULL);
	self->priv->retention_period_days = days;
}

static gboolean
clipped_clipboard_store_open_database (ClippedClipboardStore* self)
{
	gint ec = 0;
	const gchar* _tmp0_;
	sqlite3* _tmp1_ = NULL;
	gint _tmp2_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->db_location;
	_tmp2_ = sqlite3_open (_tmp0_, &_tmp1_);
	_sqlite3_close0 (self->priv->db);
	self->priv->db = _tmp1_;
	ec = _tmp2_;
	if (ec != SQLITE_OK) {
		const gchar* _tmp3_;
		_tmp3_ = self->priv->db_location;
		g_critical ("ClipboardStore.vala:72: Unable to create/open database at %s", _tmp3_);
		result = FALSE;
		return result;
	} else {
		result = TRUE;
		return result;
	}
}

static gint
_sqlite3_exec (sqlite3* self,
               const gchar* sql,
               sqlite3_callback callback,
               gpointer callback_target,
               gchar** errmsg)
{
	gchar* _vala_errmsg = NULL;
	const gchar* sqlite_errmsg = NULL;
	gint ec = 0;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_;
	const gchar* _tmp4_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (sql != NULL, 0);
	_tmp1_ = sqlite3_exec (self, sql, callback, callback_target, (char**) (&_tmp0_));
	sqlite_errmsg = _tmp0_;
	ec = _tmp1_;
	if ((&_vala_errmsg) != NULL) {
		const gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp2_ = sqlite_errmsg;
		_tmp3_ = g_strdup (_tmp2_);
		_g_free0 (_vala_errmsg);
		_vala_errmsg = _tmp3_;
	} else {
		_g_free0 (_vala_errmsg);
		_vala_errmsg = NULL;
	}
	_tmp4_ = sqlite_errmsg;
	sqlite3_free ((void*) _tmp4_);
	result = ec;
	if (errmsg) {
		*errmsg = _vala_errmsg;
	} else {
		_g_free0 (_vala_errmsg);
	}
	return result;
}

static void
clipped_clipboard_store_prepare_database (ClippedClipboardStore* self)
{
	gchar* query = NULL;
	gchar* _tmp0_;
	gchar* error_message = NULL;
	gint ec = 0;
	sqlite3* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gint _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup ("\n" \
"            CREATE TABLE entry (\n" \
"                type                INT         NOT NULL,\n" \
"                date_copied         DATETIME    NOT NULL    DEFAULT (S" \
"TRFTIME('%Y-%m-%d %H:%M:%f', 'NOW', 'localtime')),\n" \
"                last_used           DATETIME    NOT NULL    DEFAULT (S" \
"TRFTIME('%Y-%m-%d %H:%M:%f', 'NOW', 'localtime')),\n" \
"\t            text\t            TEXT,\n" \
"                application_id      TEXT,\n" \
"                application_name    TEXT,\n" \
"\t            optional_uri        TEXT,\n" \
"                optional_int        INTEGER,\n" \
"                checksum            STRING      NOT NULL,\n" \
"                UNIQUE (checksum)\n" \
"            );\n" \
"            ");
	query = _tmp0_;
	_tmp1_ = self->priv->db;
	_tmp2_ = query;
	_tmp4_ = _sqlite3_exec (_tmp1_, _tmp2_, NULL, NULL, &_tmp3_);
	_g_free0 (error_message);
	error_message = _tmp3_;
	ec = _tmp4_;
	if (ec != SQLITE_OK) {
		const gchar* _tmp5_;
		_tmp5_ = error_message;
		g_critical ("ClipboardStore.vala:97: Unable to create tables in database. Error: %s", _tmp5_);
	}
	_g_free0 (error_message);
	_g_free0 (query);
}

void
clipped_clipboard_store_insert_text_item (ClippedClipboardStore* self,
                                          const gchar* text)
{
	gchar* checksum = NULL;
	gchar* _tmp0_;
	sqlite3_stmt* stmt = NULL;
	static const char prepared_query_str[] = "INSERT OR IGNORE INTO entry (type, text, checksum) VALUES (0, $TEXT, $" \
"CHECKSUM);";
	gint ec = 0;
	sqlite3* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_;
	gint param_position = 0;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	gchar* _tmp10_;
	GDestroyNotify _tmp11_;
	sqlite3_stmt* _tmp12_;
	sqlite3_stmt* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	GDestroyNotify _tmp16_;
	sqlite3_stmt* _tmp17_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	clipped_clipboard_store_purge_older_entries (self);
	_tmp0_ = g_compute_checksum_for_string (G_CHECKSUM_SHA1, text, (gsize) -1);
	checksum = _tmp0_;
	_tmp1_ = self->priv->db;
	_tmp2_ = strlen (prepared_query_str);
	_tmp3_ = _tmp2_;
	_tmp5_ = sqlite3_prepare_v2 (_tmp1_, prepared_query_str, _tmp3_, &_tmp4_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp4_;
	ec = _tmp5_;
	if (ec != SQLITE_OK) {
		sqlite3* _tmp6_;
		const gchar* _tmp7_;
		_tmp6_ = self->priv->db;
		_tmp7_ = sqlite3_errmsg (_tmp6_);
		g_warning ("ClipboardStore.vala:110: Error inserting clipboard entry: %s\n", _tmp7_);
		_sqlite3_finalize0 (stmt);
		_g_free0 (checksum);
		return;
	}
	_tmp8_ = stmt;
	param_position = sqlite3_bind_parameter_index (_tmp8_, "$TEXT");
	_vala_assert (param_position > 0, "param_position > 0");
	_tmp9_ = stmt;
	_tmp10_ = g_strdup (text);
	_tmp11_ = g_free;
	sqlite3_bind_text (_tmp9_, param_position, _tmp10_, -1, _tmp11_);
	_tmp12_ = stmt;
	param_position = sqlite3_bind_parameter_index (_tmp12_, "$CHECKSUM");
	_vala_assert (param_position > 0, "param_position > 0");
	_tmp13_ = stmt;
	_tmp14_ = checksum;
	_tmp15_ = g_strdup (_tmp14_);
	_tmp16_ = g_free;
	sqlite3_bind_text (_tmp13_, param_position, _tmp15_, -1, _tmp16_);
	_tmp17_ = stmt;
	ec = sqlite3_step (_tmp17_);
	if (ec != SQLITE_DONE) {
		sqlite3* _tmp18_;
		const gchar* _tmp19_;
		_tmp18_ = self->priv->db;
		_tmp19_ = sqlite3_errmsg (_tmp18_);
		g_warning ("ClipboardStore.vala:124: Error inserting clipboard entry: %s\n", _tmp19_);
	}
	_sqlite3_finalize0 (stmt);
	_g_free0 (checksum);
}

GeeArrayList*
clipped_clipboard_store_get_most_recent_items (ClippedClipboardStore* self,
                                               gint limit)
{
	sqlite3_stmt* stmt = NULL;
	static const char prepared_query_str[] = "SELECT rowid, * FROM entry ORDER BY date_copied DESC LIMIT $LIMIT;";
	gint ec = 0;
	sqlite3* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint param_position = 0;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	GeeArrayList* entries = NULL;
	GeeArrayList* _tmp9_;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->db;
	_tmp1_ = strlen (prepared_query_str);
	_tmp2_ = _tmp1_;
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, prepared_query_str, _tmp2_, &_tmp3_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp3_;
	ec = _tmp4_;
	if (ec != SQLITE_OK) {
		sqlite3* _tmp5_;
		const gchar* _tmp6_;
		_tmp5_ = self->priv->db;
		_tmp6_ = sqlite3_errmsg (_tmp5_);
		g_warning ("ClipboardStore.vala:133: Error fetching clipboard entries: %s\n", _tmp6_);
		result = NULL;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	_tmp7_ = stmt;
	param_position = sqlite3_bind_parameter_index (_tmp7_, "$LIMIT");
	_vala_assert (param_position > 0, "param_position > 0");
	_tmp8_ = stmt;
	sqlite3_bind_int (_tmp8_, param_position, limit);
	_tmp9_ = gee_array_list_new (CLIPPED_CLIPBOARD_STORE_TYPE_CLIPBOARD_ENTRY, (GBoxedCopyFunc) clipped_clipboard_store_clipboard_entry_dup, (GDestroyNotify) clipped_clipboard_store_clipboard_entry_free, NULL, NULL, NULL);
	entries = _tmp9_;
	while (TRUE) {
		sqlite3_stmt* _tmp10_;
		ClippedClipboardStoreClipboardEntry entry = {0};
		sqlite3_stmt* _tmp11_;
		sqlite3_stmt* _tmp12_;
		sqlite3_stmt* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		ClippedClipboardStoreClipboardEntry _tmp16_ = {0};
		GeeArrayList* _tmp17_;
		ClippedClipboardStoreClipboardEntry _tmp18_;
		_tmp10_ = stmt;
		ec = sqlite3_step (_tmp10_);
		if (!(ec == SQLITE_ROW)) {
			break;
		}
		_tmp11_ = stmt;
		_tmp12_ = stmt;
		_tmp13_ = stmt;
		_tmp14_ = (const gchar*) sqlite3_column_text (_tmp13_, 4);
		_tmp15_ = g_strdup (_tmp14_);
		memset (&_tmp16_, 0, sizeof (ClippedClipboardStoreClipboardEntry));
		_tmp16_.id = sqlite3_column_int (_tmp11_, 0);
		_tmp16_.type = (ClippedClipboardStoreClipboardEntryType) sqlite3_column_int (_tmp12_, 1);
		_g_free0 (_tmp16_.text);
		_tmp16_.text = _tmp15_;
		entry = _tmp16_;
		_tmp17_ = entries;
		_tmp18_ = entry;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, &_tmp18_);
		clipped_clipboard_store_clipboard_entry_destroy (&entry);
	}
	if (ec != SQLITE_DONE) {
		sqlite3* _tmp19_;
		const gchar* _tmp20_;
		_tmp19_ = self->priv->db;
		_tmp20_ = sqlite3_errmsg (_tmp19_);
		g_warning ("ClipboardStore.vala:152: Error fetching clipboard entries: %s\n", _tmp20_);
		result = NULL;
		_g_object_unref0 (entries);
		_sqlite3_finalize0 (stmt);
		return result;
	}
	result = entries;
	_sqlite3_finalize0 (stmt);
	return result;
}

GeeArrayList*
clipped_clipboard_store_search (ClippedClipboardStore* self,
                                const gchar* search_term,
                                const gchar* app_search_term,
                                gint limit)
{
	sqlite3_stmt* stmt = NULL;
	gchar* wildcard_search_term = NULL;
	gchar* _tmp0_;
	gchar* wildcard_app_search_term = NULL;
	gchar* prepared_query_str = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gint ec = 0;
	sqlite3* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	sqlite3_stmt* _tmp11_ = NULL;
	gint _tmp12_;
	gint param_position = 0;
	sqlite3_stmt* _tmp15_;
	sqlite3_stmt* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	GDestroyNotify _tmp19_;
	const gchar* _tmp20_;
	sqlite3_stmt* _tmp26_;
	sqlite3_stmt* _tmp27_;
	GeeArrayList* entries = NULL;
	GeeArrayList* _tmp28_;
	GeeArrayList* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (search_term != NULL, NULL);
	_tmp0_ = g_strdup_printf ("%%%s%%", search_term);
	wildcard_search_term = _tmp0_;
	wildcard_app_search_term = NULL;
	if (app_search_term != NULL) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup_printf ("%%%s%%", app_search_term);
		_g_free0 (wildcard_app_search_term);
		wildcard_app_search_term = _tmp1_;
	}
	_tmp2_ = g_strdup ("");
	prepared_query_str = _tmp2_;
	_tmp3_ = wildcard_app_search_term;
	if (_tmp3_ != NULL) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup ("\n" \
"                SELECT rowid, * FROM entry\n" \
"                WHERE text LIKE $TEXT_SEARCH\n" \
"                AND application_name LIKE $APP_SEARCH\n" \
"                ORDER BY date_copied DESC\n" \
"                LIMIT $LIMIT;\n" \
"            ");
		_g_free0 (prepared_query_str);
		prepared_query_str = _tmp4_;
	} else {
		gchar* _tmp5_;
		_tmp5_ = g_strdup ("\n" \
"                SELECT rowid, * FROM entry\n" \
"                WHERE text LIKE $TEXT_SEARCH\n" \
"                ORDER BY date_copied DESC\n" \
"                LIMIT $LIMIT;\n" \
"            ");
		_g_free0 (prepared_query_str);
		prepared_query_str = _tmp5_;
	}
	_tmp6_ = self->priv->db;
	_tmp7_ = prepared_query_str;
	_tmp8_ = prepared_query_str;
	_tmp9_ = strlen (_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp12_ = sqlite3_prepare_v2 (_tmp6_, _tmp7_, _tmp10_, &_tmp11_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp11_;
	ec = _tmp12_;
	if (ec != SQLITE_OK) {
		sqlite3* _tmp13_;
		const gchar* _tmp14_;
		_tmp13_ = self->priv->db;
		_tmp14_ = sqlite3_errmsg (_tmp13_);
		g_warning ("ClipboardStore.vala:187: Error searching clipboard entries: %s\n", _tmp14_);
		result = NULL;
		_g_free0 (prepared_query_str);
		_g_free0 (wildcard_app_search_term);
		_g_free0 (wildcard_search_term);
		_sqlite3_finalize0 (stmt);
		return result;
	}
	_tmp15_ = stmt;
	param_position = sqlite3_bind_parameter_index (_tmp15_, "$TEXT_SEARCH");
	_vala_assert (param_position > 0, "param_position > 0");
	_tmp16_ = stmt;
	_tmp17_ = wildcard_search_term;
	_tmp18_ = g_strdup (_tmp17_);
	_tmp19_ = g_free;
	sqlite3_bind_text (_tmp16_, param_position, _tmp18_, -1, _tmp19_);
	_tmp20_ = wildcard_app_search_term;
	if (_tmp20_ != NULL) {
		sqlite3_stmt* _tmp21_;
		sqlite3_stmt* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		GDestroyNotify _tmp25_;
		_tmp21_ = stmt;
		param_position = sqlite3_bind_parameter_index (_tmp21_, "$APP_SEARCH");
		_vala_assert (param_position > 0, "param_position > 0");
		_tmp22_ = stmt;
		_tmp23_ = wildcard_app_search_term;
		_tmp24_ = g_strdup (_tmp23_);
		_tmp25_ = g_free;
		sqlite3_bind_text (_tmp22_, param_position, _tmp24_, -1, _tmp25_);
	}
	_tmp26_ = stmt;
	param_position = sqlite3_bind_parameter_index (_tmp26_, "$LIMIT");
	_vala_assert (param_position > 0, "param_position > 0");
	_tmp27_ = stmt;
	sqlite3_bind_int (_tmp27_, param_position, limit);
	_tmp28_ = gee_array_list_new (CLIPPED_CLIPBOARD_STORE_TYPE_CLIPBOARD_ENTRY, (GBoxedCopyFunc) clipped_clipboard_store_clipboard_entry_dup, (GDestroyNotify) clipped_clipboard_store_clipboard_entry_free, NULL, NULL, NULL);
	entries = _tmp28_;
	while (TRUE) {
		sqlite3_stmt* _tmp29_;
		ClippedClipboardStoreClipboardEntry entry = {0};
		sqlite3_stmt* _tmp30_;
		sqlite3_stmt* _tmp31_;
		sqlite3_stmt* _tmp32_;
		const gchar* _tmp33_;
		gchar* _tmp34_;
		ClippedClipboardStoreClipboardEntry _tmp35_ = {0};
		GeeArrayList* _tmp36_;
		ClippedClipboardStoreClipboardEntry _tmp37_;
		_tmp29_ = stmt;
		ec = sqlite3_step (_tmp29_);
		if (!(ec == SQLITE_ROW)) {
			break;
		}
		_tmp30_ = stmt;
		_tmp31_ = stmt;
		_tmp32_ = stmt;
		_tmp33_ = (const gchar*) sqlite3_column_text (_tmp32_, 4);
		_tmp34_ = g_strdup (_tmp33_);
		memset (&_tmp35_, 0, sizeof (ClippedClipboardStoreClipboardEntry));
		_tmp35_.id = sqlite3_column_int (_tmp30_, 0);
		_tmp35_.type = (ClippedClipboardStoreClipboardEntryType) sqlite3_column_int (_tmp31_, 1);
		_g_free0 (_tmp35_.text);
		_tmp35_.text = _tmp34_;
		entry = _tmp35_;
		_tmp36_ = entries;
		_tmp37_ = entry;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp36_, &_tmp37_);
		clipped_clipboard_store_clipboard_entry_destroy (&entry);
	}
	if (ec != SQLITE_DONE) {
		sqlite3* _tmp38_;
		const gchar* _tmp39_;
		_tmp38_ = self->priv->db;
		_tmp39_ = sqlite3_errmsg (_tmp38_);
		g_warning ("ClipboardStore.vala:215: Error searching clipboard entries: %s\n", _tmp39_);
		result = NULL;
		_g_object_unref0 (entries);
		_g_free0 (prepared_query_str);
		_g_free0 (wildcard_app_search_term);
		_g_free0 (wildcard_search_term);
		_sqlite3_finalize0 (stmt);
		return result;
	}
	result = entries;
	_g_free0 (prepared_query_str);
	_g_free0 (wildcard_app_search_term);
	_g_free0 (wildcard_search_term);
	_sqlite3_finalize0 (stmt);
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
clipped_clipboard_store_select_item (ClippedClipboardStore* self,
                                     gint id)
{
	sqlite3_stmt* stmt = NULL;
	static const char prepared_query_str[] = "SELECT rowid, * FROM entry WHERE rowid = $ROWID;";
	gint ec = 0;
	sqlite3* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint param_position = 0;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->db;
	_tmp1_ = strlen (prepared_query_str);
	_tmp2_ = _tmp1_;
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, prepared_query_str, _tmp2_, &_tmp3_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp3_;
	ec = _tmp4_;
	if (ec != SQLITE_OK) {
		sqlite3* _tmp5_;
		const gchar* _tmp6_;
		_tmp5_ = self->priv->db;
		_tmp6_ = sqlite3_errmsg (_tmp5_);
		g_warning ("ClipboardStore.vala:227: Error getting clipboard entry for pasting: %s" \
"\n", _tmp6_);
	}
	_tmp7_ = stmt;
	param_position = sqlite3_bind_parameter_index (_tmp7_, "$ROWID");
	_vala_assert (param_position > 0, "param_position > 0");
	_tmp8_ = stmt;
	sqlite3_bind_int (_tmp8_, param_position, id);
	_tmp9_ = stmt;
	ec = sqlite3_step (_tmp9_);
	if (ec == SQLITE_ROW) {
		gchar* text = NULL;
		sqlite3_stmt* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		GtkClipboard* clipboard = NULL;
		GdkDisplay* _tmp13_;
		GtkClipboard* _tmp14_;
		GtkClipboard* _tmp15_;
		GtkClipboard* _tmp16_;
		const gchar* _tmp17_;
		clipped_clipboard_store_touch_access_date (self, id);
		_tmp10_ = stmt;
		_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 4);
		_tmp12_ = g_strdup (_tmp11_);
		text = _tmp12_;
		_tmp13_ = gdk_display_get_default ();
		_tmp14_ = gtk_clipboard_get_default (_tmp13_);
		_tmp15_ = _g_object_ref0 (_tmp14_);
		clipboard = _tmp15_;
		_tmp16_ = clipboard;
		_tmp17_ = text;
		gtk_clipboard_set_text (_tmp16_, _tmp17_, -1);
		_g_object_unref0 (clipboard);
		_g_free0 (text);
	}
	_sqlite3_finalize0 (stmt);
}

static void
clipped_clipboard_store_touch_access_date (ClippedClipboardStore* self,
                                           gint id)
{
	sqlite3_stmt* stmt = NULL;
	static const char prepared_query_str[] = "UPDATE entry\n" \
"               SET last_used = STRFTIME('%Y-%m-%d %H:%M:%f', 'NOW', 'l" \
"ocaltime')\n" \
"               WHERE rowid = $ROWID;";
	gint ec = 0;
	sqlite3* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint param_position = 0;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->db;
	_tmp1_ = strlen (prepared_query_str);
	_tmp2_ = _tmp1_;
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, prepared_query_str, _tmp2_, &_tmp3_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp3_;
	ec = _tmp4_;
	if (ec != SQLITE_OK) {
		sqlite3* _tmp5_;
		const gchar* _tmp6_;
		_tmp5_ = self->priv->db;
		_tmp6_ = sqlite3_errmsg (_tmp5_);
		g_warning ("ClipboardStore.vala:251: Error updating last_paste date on clipboard e" \
"ntry: %s\n", _tmp6_);
	}
	_tmp7_ = stmt;
	param_position = sqlite3_bind_parameter_index (_tmp7_, "$ROWID");
	_vala_assert (param_position > 0, "param_position > 0");
	_tmp8_ = stmt;
	sqlite3_bind_int (_tmp8_, param_position, id);
	_tmp9_ = stmt;
	sqlite3_step (_tmp9_);
	_sqlite3_finalize0 (stmt);
}

static void
clipped_clipboard_store_purge_older_entries (ClippedClipboardStore* self)
{
	sqlite3_stmt* stmt = NULL;
	static const char prepared_query_str[] = "DELETE FROM entry WHERE last_used <= STRFTIME('%Y-%m-%d %H:%M:%f', 'NO" \
"W', 'localtime', $DIFFERENCE);";
	gint ec = 0;
	sqlite3* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint param_position = 0;
	sqlite3_stmt* _tmp7_;
	gchar* difference = NULL;
	gchar* _tmp8_;
	sqlite3_stmt* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	GDestroyNotify _tmp12_;
	sqlite3_stmt* _tmp13_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->db;
	_tmp1_ = strlen (prepared_query_str);
	_tmp2_ = _tmp1_;
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, prepared_query_str, _tmp2_, &_tmp3_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp3_;
	ec = _tmp4_;
	if (ec != SQLITE_OK) {
		sqlite3* _tmp5_;
		const gchar* _tmp6_;
		_tmp5_ = self->priv->db;
		_tmp6_ = sqlite3_errmsg (_tmp5_);
		g_warning ("ClipboardStore.vala:268: Error purging older clipboard entries: %s\n", _tmp6_);
	}
	_tmp7_ = stmt;
	param_position = sqlite3_bind_parameter_index (_tmp7_, "$DIFFERENCE");
	_vala_assert (param_position > 0, "param_position > 0");
	_tmp8_ = g_strdup_printf ("-%u days", self->priv->retention_period_days);
	difference = _tmp8_;
	_tmp9_ = stmt;
	_tmp10_ = difference;
	_tmp11_ = g_strdup (_tmp10_);
	_tmp12_ = g_free;
	sqlite3_bind_text (_tmp9_, param_position, _tmp11_, -1, _tmp12_);
	_tmp13_ = stmt;
	ec = sqlite3_step (_tmp13_);
	if (ec != SQLITE_DONE) {
		sqlite3* _tmp14_;
		const gchar* _tmp15_;
		_tmp14_ = self->priv->db;
		_tmp15_ = sqlite3_errmsg (_tmp14_);
		g_warning ("ClipboardStore.vala:279: Error purging older clipboard entries: %s\n", _tmp15_);
	}
	_g_free0 (difference);
	_sqlite3_finalize0 (stmt);
}

void
clipped_clipboard_store_delete_item (ClippedClipboardStore* self,
                                     gint id)
{
	sqlite3_stmt* stmt = NULL;
	static const char prepared_query_str[] = "DELETE FROM entry WHERE rowid = $ROWID;";
	gint ec = 0;
	sqlite3* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint param_position = 0;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	sqlite3_stmt* _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->db;
	_tmp1_ = strlen (prepared_query_str);
	_tmp2_ = _tmp1_;
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, prepared_query_str, _tmp2_, &_tmp3_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp3_;
	ec = _tmp4_;
	if (ec != SQLITE_OK) {
		sqlite3* _tmp5_;
		const gchar* _tmp6_;
		_tmp5_ = self->priv->db;
		_tmp6_ = sqlite3_errmsg (_tmp5_);
		g_warning ("ClipboardStore.vala:288: Error getting clipboard entry for pasting: %s" \
"\n", _tmp6_);
	}
	_tmp7_ = stmt;
	param_position = sqlite3_bind_parameter_index (_tmp7_, "$ROWID");
	_vala_assert (param_position > 0, "param_position > 0");
	_tmp8_ = stmt;
	sqlite3_bind_int (_tmp8_, param_position, id);
	_tmp9_ = stmt;
	sqlite3_step (_tmp9_);
	_sqlite3_finalize0 (stmt);
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
	return self ? g_date_time_ref (self) : NULL;
}

void
clipped_clipboard_store_clipboard_entry_copy (const ClippedClipboardStoreClipboardEntry* self,
                                              ClippedClipboardStoreClipboardEntry* dest)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	(*dest).id = (*self).id;
	(*dest).type = (*self).type;
	_tmp0_ = (*self).date_copied;
	_tmp1_ = _g_date_time_ref0 (_tmp0_);
	_g_date_time_unref0 ((*dest).date_copied);
	(*dest).date_copied = _tmp1_;
	_tmp2_ = (*self).text;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).text);
	(*dest).text = _tmp3_;
	_tmp4_ = (*self).application_id;
	_tmp5_ = g_strdup (_tmp4_);
	_g_free0 ((*dest).application_id);
	(*dest).application_id = _tmp5_;
	_tmp6_ = (*self).application_name;
	_tmp7_ = g_strdup (_tmp6_);
	_g_free0 ((*dest).application_name);
	(*dest).application_name = _tmp7_;
	_tmp8_ = (*self).optional_uri;
	_tmp9_ = g_strdup (_tmp8_);
	_g_free0 ((*dest).optional_uri);
	(*dest).optional_uri = _tmp9_;
	(*dest).optional_int = (*self).optional_int;
}

void
clipped_clipboard_store_clipboard_entry_destroy (ClippedClipboardStoreClipboardEntry* self)
{
	_g_date_time_unref0 ((*self).date_copied);
	_g_free0 ((*self).text);
	_g_free0 ((*self).application_id);
	_g_free0 ((*self).application_name);
	_g_free0 ((*self).optional_uri);
}

ClippedClipboardStoreClipboardEntry*
clipped_clipboard_store_clipboard_entry_dup (const ClippedClipboardStoreClipboardEntry* self)
{
	ClippedClipboardStoreClipboardEntry* dup;
	dup = g_new0 (ClippedClipboardStoreClipboardEntry, 1);
	clipped_clipboard_store_clipboard_entry_copy (self, dup);
	return dup;
}

void
clipped_clipboard_store_clipboard_entry_free (ClippedClipboardStoreClipboardEntry* self)
{
	clipped_clipboard_store_clipboard_entry_destroy (self);
	g_free (self);
}

static GType
clipped_clipboard_store_clipboard_entry_get_type_once (void)
{
	GType clipped_clipboard_store_clipboard_entry_type_id;
	clipped_clipboard_store_clipboard_entry_type_id = g_boxed_type_register_static ("ClippedClipboardStoreClipboardEntry", (GBoxedCopyFunc) clipped_clipboard_store_clipboard_entry_dup, (GBoxedFreeFunc) clipped_clipboard_store_clipboard_entry_free);
	return clipped_clipboard_store_clipboard_entry_type_id;
}

GType
clipped_clipboard_store_clipboard_entry_get_type (void)
{
	static volatile gsize clipped_clipboard_store_clipboard_entry_type_id__once = 0;
	if (g_once_init_enter (&clipped_clipboard_store_clipboard_entry_type_id__once)) {
		GType clipped_clipboard_store_clipboard_entry_type_id;
		clipped_clipboard_store_clipboard_entry_type_id = clipped_clipboard_store_clipboard_entry_get_type_once ();
		g_once_init_leave (&clipped_clipboard_store_clipboard_entry_type_id__once, clipped_clipboard_store_clipboard_entry_type_id);
	}
	return clipped_clipboard_store_clipboard_entry_type_id__once;
}

static void
clipped_clipboard_store_class_init (ClippedClipboardStoreClass * klass,
                                    gpointer klass_data)
{
	clipped_clipboard_store_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ClippedClipboardStore_private_offset);
	G_OBJECT_CLASS (klass)->finalize = clipped_clipboard_store_finalize;
}

static void
clipped_clipboard_store_instance_init (ClippedClipboardStore * self,
                                       gpointer klass)
{
	self->priv = clipped_clipboard_store_get_instance_private (self);
	self->priv->retention_period_days = (guint) 7;
}

static void
clipped_clipboard_store_finalize (GObject * obj)
{
	ClippedClipboardStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CLIPPED_TYPE_CLIPBOARD_STORE, ClippedClipboardStore);
	_g_free0 (self->priv->db_location);
	_sqlite3_close0 (self->priv->db);
	G_OBJECT_CLASS (clipped_clipboard_store_parent_class)->finalize (obj);
}

static GType
clipped_clipboard_store_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClippedClipboardStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clipped_clipboard_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClippedClipboardStore), 0, (GInstanceInitFunc) clipped_clipboard_store_instance_init, NULL };
	GType clipped_clipboard_store_type_id;
	clipped_clipboard_store_type_id = g_type_register_static (G_TYPE_OBJECT, "ClippedClipboardStore", &g_define_type_info, 0);
	ClippedClipboardStore_private_offset = g_type_add_instance_private (clipped_clipboard_store_type_id, sizeof (ClippedClipboardStorePrivate));
	return clipped_clipboard_store_type_id;
}

GType
clipped_clipboard_store_get_type (void)
{
	static volatile gsize clipped_clipboard_store_type_id__once = 0;
	if (g_once_init_enter (&clipped_clipboard_store_type_id__once)) {
		GType clipped_clipboard_store_type_id;
		clipped_clipboard_store_type_id = clipped_clipboard_store_get_type_once ();
		g_once_init_leave (&clipped_clipboard_store_type_id__once, clipped_clipboard_store_type_id);
	}
	return clipped_clipboard_store_type_id__once;
}

